=== roms/u-boot/board/sbc8641d/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2001
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.

obj-y	+= sbc8641d.o
obj-y	+= law.o
obj-$(CONFIG_SYS_FSL_DDR2) += ddr.o
