=== roms/u-boot/board/rockchip/evb_rk3288/Makefile ===
#
# (C) Copyright 2016 Rockchip Electronics Co., Ltd
#
# SPDX-License-Identifier:     GPL-2.0+
#

obj-y	+= evb-rk3288.o
