=== roms/u-boot/post/cpu/mpc83xx/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2002-2007
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.

obj-y += ecc.o
