=== roms/u-boot/arch/x86/lib/coreboot/Makefile ===
# SPDX-License-Identifier:	GPL-2.0+
#
# Copyright 2021 Google LLC
#

obj-y += cb_sysinfo.o
obj-y += cb_support.o
